现在的位置: 首页 > 综合 > 正文

Prime Path(POJ 3126)

2015年11月21日 ⁄ 综合 ⁄ 共 2601字 ⁄ 字号 评论关闭

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033 
1733 
3733 
3739 
3779 
8779 
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0
#include<iostream>
#include<queue>
#include<string.h>
using namespace std;
bool prime[10000];
int state[10000];
int pre,obj;
queue<int> record;
void Init(){
    for(int i=0;i<10000;i++) prime[i]=true;
    for(int i=2;i<10000;i++){
        if(prime[i]){
            for(int j=2;i*j<10000;j++) prime[i*j]=false;
        }
    }
}
int BFS(){
    if(pre==obj) return 0;
    int multi[4]={1,10,100,1000};
    int cur;
    state[pre]=1;
    record.push(pre);
    while(!record.empty()){
        cur=record.front();
        record.pop();
        int d[4];
        d[0]=(cur/10)*10;
        d[1]=(cur/100)*100+cur%10;
        d[2]=(cur/1000)*1000+cur%100;
        d[3]=cur%1000;
        int digit;
        for(int a=0;a<4;a++){
            for(int b=0;b<=9;b++){
                if(a==3&&b==0) continue;
                digit=d[a]+multi[a]*b;
                if(digit==obj) return state[cur];
                if(prime[digit]&&!state[digit]){
                    record.push(digit);
                    state[digit]=state[cur]+1;
                }
            }
        }
    }
    return -1;
}
int main(){
    Init();
    int ncase;
    cin>>ncase;
    while(ncase--){
        cin>>pre>>obj;
        while(!record.empty()) record.pop();
        memset(state,0,sizeof(state));
        int res;
        res=BFS();
        if(res==-1) cout<<"Impossible"<<endl;
        else cout<<res<<endl;
    }
}

抱歉!评论已关闭.